"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unflattenRemoveArrayStateUpdate = exports.unflattenArrayStateUpdate = exports.unflatten = void 0;

var _getValue = _interopRequireDefault(require("./get-value"));

var _flat = require("flat");

var _isObject = _interopRequireDefault(require("./is-object"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var unflatten = function unflatten(path, value) {
  if (typeof path === "string") {
    path = _defineProperty({}, "".concat(path), value);
  }

  return (0, _flat.unflatten)(path, {
    object: true
  });
};

exports.unflatten = unflatten;

var unflattenArrayStateUpdate = function unflattenArrayStateUpdate(state, path, value) {
  if (!(0, _isObject.default)(path)) {
    path = _defineProperty({}, path, value);
  }

  var o = Object.keys(path).reduce(function (acc, item) {
    var pathValue = (0, _getValue.default)(state, item);

    if (Array.isArray(pathValue)) {
      acc["".concat(item, ".$push")] = [path[item]];
    } else {
      acc["".concat(item, ".$set")] = [path[item]];
    }

    return acc;
  }, {});
  return unflatten(o);
};

exports.unflattenArrayStateUpdate = unflattenArrayStateUpdate;

var unflattenRemoveArrayStateUpdate = function unflattenRemoveArrayStateUpdate(path) {
  if (!Array.isArray(path)) {
    path = [path];
  }

  var paths = path.reduce(function (acc, path) {
    var pathSegments = path.split('.');
    var index = parseInt(pathSegments.pop(), 10);
    var splicePath = "".concat(pathSegments.join('.'), ".$splice");

    if (acc[splicePath]) {
      acc[splicePath].push([index, 1]);
    } else {
      acc[splicePath] = [[index, 1]];
    }

    return acc;
  }, {});
  return unflatten(paths);
}; // export const unflattenRemoveArrayStateUpdate = (path: string): Object => {
//   const pathSegments: Array<any> = path.split('.')
//   const index: number = parseInt(pathSegments.pop(), 10)
//   return unflatten(`${pathSegments.join('.')}.$splice`, [[index, 1]])
// }


exports.unflattenRemoveArrayStateUpdate = unflattenRemoveArrayStateUpdate;